test-lib: add helper functions for config
[git/git.git] / t / test-lib.sh
CommitLineData
e1970ce4
JH
1#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano
4#
64b90323
MS
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
e1970ce4 17
44138559
JS
18# if --tee was passed, write the output not only to the terminal, but
19# additionally to the file test-results/$BASENAME.out, too.
20case "$GIT_TEST_TEE_STARTED, $* " in
21done,*)
22 # do not redirect again
23 ;;
3da93652 24*' --tee '*|*' --va'*)
44138559
JS
25 mkdir -p test-results
26 BASE=test-results/$(basename "$0" .sh)
27 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28 echo $? > $BASE.exit) | tee $BASE.out
29 test "$(cat $BASE.exit)" = 0
30 exit
31 ;;
32esac
33
c2116a17
JH
34# Keep the original TERM for say_color
35ORIGINAL_TERM=$TERM
36
e1970ce4
JH
37# For repeatability, reset the environment to known value.
38LANG=C
899460f3 39LC_ALL=C
d9bdd39e 40PAGER=cat
e1970ce4 41TZ=UTC
c2116a17
JH
42TERM=dumb
43export LANG LC_ALL PAGER TERM TZ
8ff99e74 44EDITOR=:
d33738d7 45unset VISUAL
28a94f88 46unset EMAIL
95a1d12e
JN
47unset $(perl -e '
48 my @env = keys %ENV;
730477f1
JL
49 my $ok = join("|", qw(
50 TRACE
51 DEBUG
52 USE_LOOKUP
53 TEST
54 .*_TEST
55 PROVE
56 VALGRIND
57 ));
58 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
95a1d12e
JN
59 print join("\n", @vars);
60')
29e55cd5
JH
61GIT_AUTHOR_EMAIL=author@example.com
62GIT_AUTHOR_NAME='A U Thor'
29e55cd5
JH
63GIT_COMMITTER_EMAIL=committer@example.com
64GIT_COMMITTER_NAME='C O Mitter'
8d0fc48f
SP
65GIT_MERGE_VERBOSITY=5
66export GIT_MERGE_VERBOSITY
29e55cd5
JH
67export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
68export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
d33738d7 69export EDITOR
e1970ce4 70
886a3907
JH
71# Protect ourselves from common misconfiguration to export
72# CDPATH into the environment
73unset CDPATH
74
5565f47c
BW
75unset GREP_OPTIONS
76
3d5c0cc9 77case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
6ce4e61f
CC
78 1|2|true)
79 echo "* warning: Some tests will not work if GIT_TRACE" \
80 "is set as to trace on STDERR ! *"
81 echo "* warning: Please set GIT_TRACE to something" \
82 "other than 1, 2 or true ! *"
83 ;;
84esac
85
cd3c095c
JH
86# Convenience
87#
88# A regexp to match 5 and 40 hexdigits
89_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
90_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
91
3749fde5
JH
92# Zero SHA-1
93_z40=0000000000000000000000000000000000000000
94
e1970ce4
JH
95# Each test should start with something like this, after copyright notices:
96#
97# test_description='Description of this test...
98# This test checks if command xyzzy does the right thing...
99# '
100# . ./test-lib.sh
c2116a17
JH
101[ "x$ORIGINAL_TERM" != "xdumb" ] && (
102 TERM=$ORIGINAL_TERM &&
103 export TERM &&
104 [ -t 1 ] &&
105 tput bold >/dev/null 2>&1 &&
106 tput setaf 1 >/dev/null 2>&1 &&
107 tput sgr0 >/dev/null 2>&1
108 ) &&
55db1df0 109 color=t
e1970ce4 110
e1970ce4
JH
111while test "$#" -ne 0
112do
113 case "$1" in
114 -d|--d|--de|--deb|--debu|--debug)
115 debug=t; shift ;;
886856ab
JH
116 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
117 immediate=t; shift ;;
5e2c08c6 118 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
91e80b98 119 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
e1970ce4 120 -h|--h|--he|--hel|--help)
570f3226 121 help=t; shift ;;
e1970ce4
JH
122 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
123 verbose=t; shift ;;
1ece1274 124 -q|--q|--qu|--qui|--quie|--quiet)
092c4334
ÆAB
125 # Ignore --quiet under a TAP::Harness. Saying how many tests
126 # passed without the ok/not ok details is always an error.
127 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
e4597aae
MO
128 --with-dashes)
129 with_dashes=t; shift ;;
55db1df0 130 --no-color)
faa4bc35 131 color=; shift ;;
4e1be63c 132 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
3da93652 133 valgrind=t; verbose=t; shift ;;
44138559
JS
134 --tee)
135 shift ;; # was handled already
f423ef5f
JK
136 --root=*)
137 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
138 shift ;;
e1970ce4 139 *)
1f729dca 140 echo "error: unknown test option '$1'" >&2; exit 1 ;;
e1970ce4
JH
141 esac
142done
143
55db1df0
PH
144if test -n "$color"; then
145 say_color () {
c2116a17
JH
146 (
147 TERM=$ORIGINAL_TERM
148 export TERM
55db1df0
PH
149 case "$1" in
150 error) tput bold; tput setaf 1;; # bold red
151 skip) tput bold; tput setaf 2;; # bold green
152 pass) tput setaf 2;; # green
153 info) tput setaf 3;; # brown
1ece1274 154 *) test -n "$quiet" && return;;
55db1df0
PH
155 esac
156 shift
5099b99d 157 printf "%s" "$*"
55db1df0 158 tput sgr0
b8eecafd 159 echo
c2116a17 160 )
55db1df0
PH
161 }
162else
163 say_color() {
1ece1274 164 test -z "$1" && test -n "$quiet" && return
55db1df0 165 shift
5099b99d 166 echo "$*"
55db1df0
PH
167 }
168fi
169
170error () {
171 say_color error "error: $*"
6e7b5aaf 172 GIT_EXIT_OK=t
55db1df0
PH
173 exit 1
174}
175
176say () {
177 say_color info "$*"
178}
179
570f3226
MB
180test "${test_description}" != "" ||
181error "Test script did not set test_description."
182
183if test "$help" = "t"
184then
185 echo "$test_description"
186 exit 0
187fi
188
4d9d62fa 189exec 5>&1
e1970ce4
JH
190if test "$verbose" = "t"
191then
192 exec 4>&2 3>&1
193else
194 exec 4>/dev/null 3>/dev/null
195fi
196
197test_failure=0
198test_count=0
41ac414e
JH
199test_fixed=0
200test_broken=0
2d84e9fb 201test_success=0
e1970ce4 202
d998bd4a
ÆAB
203test_external_has_tap=0
204
faa4bc35 205die () {
6e7b5aaf
CB
206 code=$?
207 if test -n "$GIT_EXIT_OK"
208 then
209 exit $code
210 else
211 echo >&5 "FATAL: Unexpected exit with code $code"
212 exit 1
213 fi
faa4bc35
CB
214}
215
6e7b5aaf 216GIT_EXIT_OK=
35641310 217trap 'die' EXIT
41184273 218
02b35660
BD
219# The semantics of the editor variables are that of invoking
220# sh -c "$EDITOR \"$@\"" files ...
221#
222# If our trash directory contains shell metacharacters, they will be
223# interpreted if we just set $EDITOR directly, so do a little dance with
224# environment variables to work around this.
225#
226# In particular, quoting isn't enough, as the path may contain the same quote
7b7b4516 227# that we're using.
02b35660
BD
228test_set_editor () {
229 FAKE_EDITOR="$1"
230 export FAKE_EDITOR
d33738d7
JN
231 EDITOR='"$FAKE_EDITOR"'
232 export EDITOR
02b35660
BD
233}
234
68cfc6f5 235test_decode_color () {
a471833d
KB
236 awk '
237 function name(n) {
238 if (n == 0) return "RESET";
239 if (n == 1) return "BOLD";
240 if (n == 30) return "BLACK";
241 if (n == 31) return "RED";
242 if (n == 32) return "GREEN";
243 if (n == 33) return "YELLOW";
244 if (n == 34) return "BLUE";
245 if (n == 35) return "MAGENTA";
246 if (n == 36) return "CYAN";
247 if (n == 37) return "WHITE";
248 if (n == 40) return "BLACK";
249 if (n == 41) return "BRED";
250 if (n == 42) return "BGREEN";
251 if (n == 43) return "BYELLOW";
252 if (n == 44) return "BBLUE";
253 if (n == 45) return "BMAGENTA";
254 if (n == 46) return "BCYAN";
255 if (n == 47) return "BWHITE";
256 }
257 {
c2ed29b4 258 while (match($0, /\033\[[0-9;]*m/) != 0) {
a471833d
KB
259 printf "%s<", substr($0, 1, RSTART-1);
260 codes = substr($0, RSTART+2, RLENGTH-3);
261 if (length(codes) == 0)
262 printf "%s", name(0)
263 else {
264 n = split(codes, ary, ";");
265 sep = "";
266 for (i = 1; i <= n; i++) {
267 printf "%s%s", sep, name(ary[i]);
268 sep = ";"
269 }
270 }
271 printf ">";
272 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
273 }
274 print
275 }
276 '
68cfc6f5
MG
277}
278
9130ac9f
JK
279nul_to_q () {
280 perl -pe 'y/\000/Q/'
281}
282
c4f3f551
SB
283q_to_nul () {
284 perl -pe 'y/Q/\000/'
285}
286
287q_to_cr () {
288 tr Q '\015'
289}
290
800f1104
JN
291q_to_tab () {
292 tr Q '\011'
293}
294
c4f3f551
SB
295append_cr () {
296 sed -e 's/$/Q/' | tr Q '\015'
297}
298
299remove_cr () {
300 tr '\015' Q | sed -e 's/Q$//'
301}
302
00648ba0
EN
303# In some bourne shell implementations, the "unset" builtin returns
304# nonzero status when a variable to be unset was not set in the first
305# place.
306#
307# Use sane_unset when that should not be considered an error.
308
309sane_unset () {
310 unset "$@"
311 return 0
312}
313
04509738
JH
314test_tick () {
315 if test -z "${test_tick+set}"
316 then
21afc41c 317 test_tick=1112911993
04509738
JH
318 else
319 test_tick=$(($test_tick + 60))
320 fi
21afc41c
JH
321 GIT_COMMITTER_DATE="$test_tick -0700"
322 GIT_AUTHOR_DATE="$test_tick -0700"
04509738
JH
323 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
324}
e1970ce4 325
00884968
JS
326# Call test_commit with the arguments "<message> [<file> [<contents>]]"
327#
328# This will commit a file with the given contents and the given commit
329# message. It will also add a tag with <message> as name.
330#
331# Both <file> and <contents> default to <message>.
332
333test_commit () {
e656fc97 334 file=${2:-"$1.t"}
00884968
JS
335 echo "${3-$1}" > "$file" &&
336 git add "$file" &&
337 test_tick &&
338 git commit -m "$1" &&
339 git tag "$1"
340}
341
342# Call test_merge with the arguments "<message> <commit>", where <commit>
343# can be a tag pointing to the commit-to-merge.
344
345test_merge () {
346 test_tick &&
347 git merge -m "$1" "$2" &&
348 git tag "$1"
349}
350
1f553918
JS
351# This function helps systems where core.filemode=false is set.
352# Use it instead of plain 'chmod +x' to set or unset the executable bit
353# of a file in the working directory and add it to the index.
354
355test_chmod () {
356 chmod "$@" &&
357 git update-index --add "--chmod=$@"
358}
359
d960c47a
JK
360# Unset a configuration variable, but don't fail if it doesn't exist.
361test_unconfig () {
362 git config --unset-all "$@"
363 config_status=$?
364 case "$config_status" in
365 5) # ok, nothing to unset
366 config_status=0
367 ;;
368 esac
369 return $config_status
370}
371
372# Set git config, automatically unsetting it after the test is over.
373test_config () {
374 test_when_finished "test_unconfig '$1'" &&
375 git config "$@"
376}
377
a7bb3940
JS
378# Use test_set_prereq to tell that a particular prerequisite is available.
379# The prerequisite can later be checked for in two ways:
380#
381# - Explicitly using test_have_prereq.
382#
383# - Implicitly by specifying the prerequisite tag in the calls to
384# test_expect_{success,failure,code}.
385#
386# The single parameter is the prerequisite tag (a simple word, in all
387# capital letters by convention).
388
389test_set_prereq () {
390 satisfied="$satisfied$1 "
391}
392satisfied=" "
393
394test_have_prereq () {
93a57246
ÆAB
395 # prerequisites can be concatenated with ','
396 save_IFS=$IFS
397 IFS=,
398 set -- $*
399 IFS=$save_IFS
ce60653e
ÆAB
400
401 total_prereq=0
402 ok_prereq=0
403 missing_prereq=
404
93a57246
ÆAB
405 for prerequisite
406 do
ce60653e 407 total_prereq=$(($total_prereq + 1))
93a57246
ÆAB
408 case $satisfied in
409 *" $prerequisite "*)
ce60653e
ÆAB
410 ok_prereq=$(($ok_prereq + 1))
411 ;;
93a57246 412 *)
ce60653e
ÆAB
413 # Keep a list of missing prerequisites
414 if test -z "$missing_prereq"
415 then
416 missing_prereq=$prerequisite
417 else
418 missing_prereq="$prerequisite,$missing_prereq"
419 fi
93a57246
ÆAB
420 esac
421 done
ce60653e
ÆAB
422
423 test $total_prereq = $ok_prereq
a7bb3940
JS
424}
425
05236a5e
JN
426test_declared_prereq () {
427 case ",$test_prereq," in
428 *,$1,*)
429 return 0
430 ;;
431 esac
432 return 1
433}
434
886856ab
JH
435# You are not expected to call test_ok_ and test_failure_ directly, use
436# the text_expect_* functions instead.
437
438test_ok_ () {
d5d9de1b 439 test_success=$(($test_success + 1))
5099b99d 440 say_color "" "ok $test_count - $@"
e1970ce4
JH
441}
442
886856ab 443test_failure_ () {
d5d9de1b 444 test_failure=$(($test_failure + 1))
5099b99d 445 say_color error "not ok - $test_count $1"
bf0dd8a8 446 shift
5099b99d 447 echo "$@" | sed -e 's/^/# /'
6e7b5aaf 448 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
886856ab
JH
449}
450
41ac414e 451test_known_broken_ok_ () {
41ac414e 452 test_fixed=$(($test_fixed+1))
5099b99d 453 say_color "" "ok $test_count - $@ # TODO known breakage"
41ac414e
JH
454}
455
456test_known_broken_failure_ () {
41ac414e 457 test_broken=$(($test_broken+1))
5099b99d 458 say_color skip "not ok $test_count - $@ # TODO known breakage"
41ac414e 459}
886856ab
JH
460
461test_debug () {
8e832ebc 462 test "$debug" = "" || eval "$1"
e1970ce4
JH
463}
464
4d9d62fa 465test_run_ () {
b6b0afdc 466 test_cleanup=:
b586744a 467 expecting_failure=$2
4d9d62fa 468 eval >&3 2>&4 "$1"
b6b0afdc 469 eval_ret=$?
b586744a
JH
470
471 if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
472 then
473 eval >&3 2>&4 "$test_cleanup"
474 fi
57e1538a
ÆAB
475 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
476 echo ""
477 fi
4d9d62fa
PR
478 return 0
479}
480
04ece593 481test_skip () {
8586f98b 482 test_count=$(($test_count+1))
04ece593
JH
483 to_skip=
484 for skp in $GIT_SKIP_TESTS
485 do
8586f98b 486 case $this_test.$test_count in
04ece593
JH
487 $skp)
488 to_skip=t
47e67d47 489 break
04ece593
JH
490 esac
491 done
05236a5e
JN
492 if test -z "$to_skip" && test -n "$test_prereq" &&
493 ! test_have_prereq "$test_prereq"
a7bb3940
JS
494 then
495 to_skip=t
496 fi
04ece593
JH
497 case "$to_skip" in
498 t)
07431fc8 499 of_prereq=
05236a5e 500 if test "$missing_prereq" != "$test_prereq"
07431fc8 501 then
05236a5e 502 of_prereq=" of $test_prereq"
07431fc8
JN
503 fi
504
55db1df0 505 say_color skip >&3 "skipping test: $@"
07431fc8 506 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
04ece593
JH
507 : true
508 ;;
509 *)
510 false
511 ;;
512 esac
513}
514
e1970ce4 515test_expect_failure () {
05236a5e 516 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
8e832ebc 517 test "$#" = 2 ||
a7bb3940 518 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
05236a5e 519 export test_prereq
04ece593 520 if ! test_skip "$@"
e1970ce4 521 then
41ac414e 522 say >&3 "checking known breakage: $2"
b586744a 523 test_run_ "$2" expecting_failure
41ac414e 524 if [ "$?" = 0 -a "$eval_ret" = 0 ]
04ece593 525 then
41ac414e 526 test_known_broken_ok_ "$1"
04ece593 527 else
6e7b5aaf 528 test_known_broken_failure_ "$1"
04ece593 529 fi
e1970ce4 530 fi
7a0cf2d0 531 echo >&3 ""
e1970ce4
JH
532}
533
534test_expect_success () {
05236a5e 535 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
8e832ebc 536 test "$#" = 2 ||
a7bb3940 537 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
05236a5e 538 export test_prereq
04ece593 539 if ! test_skip "$@"
e1970ce4 540 then
04ece593
JH
541 say >&3 "expecting success: $2"
542 test_run_ "$2"
543 if [ "$?" = 0 -a "$eval_ret" = 0 ]
544 then
545 test_ok_ "$1"
546 else
547 test_failure_ "$@"
548 fi
e1970ce4 549 fi
7a0cf2d0 550 echo >&3 ""
e1970ce4
JH
551}
552
fb32c410
LW
553# test_external runs external test scripts that provide continuous
554# test output about their progress, and succeeds/fails on
555# zero/non-zero exit code. It outputs the test output on stdout even
d998bd4a 556# in non-verbose mode, and announces the external script with "# run
fb32c410
LW
557# <n>: ..." before running it. When providing relative paths, keep in
558# mind that all scripts run in "trash directory".
559# Usage: test_external description command arguments...
560# Example: test_external 'Perl API' perl ../path/to/test.pl
561test_external () {
05236a5e 562 test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
a7bb3940
JS
563 test "$#" = 3 ||
564 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
fb32c410
LW
565 descr="$1"
566 shift
05236a5e 567 export test_prereq
fb32c410
LW
568 if ! test_skip "$descr" "$@"
569 then
570 # Announce the script to reduce confusion about the
571 # test output that follows.
d998bd4a 572 say_color "" "# run $test_count: $descr ($*)"
5ae8030f
JN
573 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
574 # to be able to use them in script
575 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
fb32c410
LW
576 # Run command; redirect its stderr to &4 as in
577 # test_run_, but keep its stdout on our stdout even in
578 # non-verbose mode.
579 "$@" 2>&4
580 if [ "$?" = 0 ]
581 then
d998bd4a
ÆAB
582 if test $test_external_has_tap -eq 0; then
583 test_ok_ "$descr"
584 else
585 say_color "" "# test_external test $descr was ok"
586 test_success=$(($test_success + 1))
587 fi
fb32c410 588 else
d998bd4a
ÆAB
589 if test $test_external_has_tap -eq 0; then
590 test_failure_ "$descr" "$@"
591 else
592 say_color error "# test_external test $descr failed: $@"
593 test_failure=$(($test_failure + 1))
594 fi
fb32c410
LW
595 fi
596 fi
597}
598
599# Like test_external, but in addition tests that the command generated
600# no output on stderr.
601test_external_without_stderr () {
602 # The temporary file has no (and must have no) security
603 # implications.
c54e6be7 604 tmp=${TMPDIR:-/tmp}
fb32c410
LW
605 stderr="$tmp/git-external-stderr.$$.tmp"
606 test_external "$@" 4> "$stderr"
607 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
608 descr="no stderr: $1"
609 shift
d998bd4a 610 say >&3 "# expecting no stderr from previous command"
fb32c410
LW
611 if [ ! -s "$stderr" ]; then
612 rm "$stderr"
d998bd4a
ÆAB
613
614 if test $test_external_has_tap -eq 0; then
615 test_ok_ "$descr"
616 else
617 say_color "" "# test_external_without_stderr test $descr was ok"
618 test_success=$(($test_success + 1))
619 fi
fb32c410
LW
620 else
621 if [ "$verbose" = t ]; then
d998bd4a 622 output=`echo; echo "# Stderr is:"; cat "$stderr"`
fb32c410
LW
623 else
624 output=
625 fi
626 # rm first in case test_failure exits.
627 rm "$stderr"
d998bd4a
ÆAB
628 if test $test_external_has_tap -eq 0; then
629 test_failure_ "$descr" "$@" "$output"
630 else
631 say_color error "# test_external_without_stderr test $descr failed: $@: $output"
632 test_failure=$(($test_failure + 1))
633 fi
fb32c410
LW
634 fi
635}
636
2caf20c5
MM
637# debugging-friendly alternatives to "test [-f|-d|-e]"
638# The commands test the existence or non-existence of $1. $2 can be
639# given to provide a more precise diagnosis.
640test_path_is_file () {
641 if ! [ -f "$1" ]
642 then
643 echo "File $1 doesn't exist. $*"
644 false
645 fi
646}
647
648test_path_is_dir () {
649 if ! [ -d "$1" ]
650 then
651 echo "Directory $1 doesn't exist. $*"
652 false
653 fi
654}
655
656test_path_is_missing () {
657 if [ -e "$1" ]
658 then
659 echo "Path exists:"
660 ls -ld "$1"
661 if [ $# -ge 1 ]; then
662 echo "$*"
663 fi
664 false
665 fi
666}
667
fb3340a6
JN
668# test_line_count checks that a file has the number of lines it
669# ought to. For example:
670#
671# test_expect_success 'produce exactly one line of output' '
672# do something >output &&
673# test_line_count = 1 output
674# '
675#
676# is like "test $(wc -l <output) = 1" except that it passes the
677# output through when the number of lines is wrong.
678
679test_line_count () {
680 if test $# != 3
681 then
682 error "bug in the test script: not 3 parameters to test_line_count"
683 elif ! test $(wc -l <"$3") "$1" "$2"
684 then
685 echo "test_line_count: line count for $3 !$1 $2"
686 cat "$3"
687 return 1
688 fi
689}
2caf20c5 690
74359821
JH
691# This is not among top-level (test_expect_success | test_expect_failure)
692# but is a prefix that can be used in the test script, like:
693#
694# test_expect_success 'complain and die' '
695# do something &&
696# do something else &&
697# test_must_fail git checkout ../outerspace
698# '
699#
700# Writing this as "! git checkout ../outerspace" is wrong, because
701# the failure could be due to a segv. We want a controlled failure.
702
703test_must_fail () {
704 "$@"
16034fbe
JK
705 exit_code=$?
706 if test $exit_code = 0; then
707 echo >&2 "test_must_fail: command succeeded: $*"
708 return 1
709 elif test $exit_code -gt 129 -a $exit_code -le 192; then
710 echo >&2 "test_must_fail: died by signal: $*"
711 return 1
a54ce3ca
JK
712 elif test $exit_code = 127; then
713 echo >&2 "test_must_fail: command not found: $*"
714 return 1
16034fbe
JK
715 fi
716 return 0
74359821
JH
717}
718
fdf1bc48
JN
719# Similar to test_must_fail, but tolerates success, too. This is
720# meant to be used in contexts like:
721#
722# test_expect_success 'some command works without configuration' '
723# test_might_fail git config --unset all.configuration &&
724# do something
725# '
726#
727# Writing "git config --unset all.configuration || :" would be wrong,
728# because we want to notice if it fails due to segv.
729
730test_might_fail () {
731 "$@"
5c8e1414
JN
732 exit_code=$?
733 if test $exit_code -gt 129 -a $exit_code -le 192; then
734 echo >&2 "test_might_fail: died by signal: $*"
735 return 1
d0b8a617
JN
736 elif test $exit_code = 127; then
737 echo >&2 "test_might_fail: command not found: $*"
738 return 1
5c8e1414
JN
739 fi
740 return 0
fdf1bc48
JN
741}
742
892e6f7e
ÆAB
743# Similar to test_must_fail and test_might_fail, but check that a
744# given command exited with a given exit code. Meant to be used as:
745#
746# test_expect_success 'Merge with d/f conflicts' '
747# test_expect_code 1 git merge "merge msg" B master
748# '
749
750test_expect_code () {
751 want_code=$1
752 shift
753 "$@"
754 exit_code=$?
755 if test $exit_code = $want_code
756 then
892e6f7e 757 return 0
892e6f7e 758 fi
f5b7ce1b
JN
759
760 echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
761 return 1
892e6f7e
ÆAB
762}
763
82ebb0b6
JK
764# test_cmp is a helper function to compare actual and expected output.
765# You can use it like:
766#
767# test_expect_success 'foo works' '
768# echo expected >expected &&
769# foo >actual &&
770# test_cmp expected actual
771# '
772#
773# This could be written as either "cmp" or "diff -u", but:
774# - cmp's output is not nearly as easy to read as diff -u
775# - not all diff versions understand "-u"
776
777test_cmp() {
778 $GIT_TEST_CMP "$@"
779}
780
3bf78867
JN
781# This function can be used to schedule some commands to be run
782# unconditionally at the end of the test to restore sanity:
783#
784# test_expect_success 'test core.capslock' '
785# git config core.capslock true &&
786# test_when_finished "git config --unset core.capslock" &&
787# hello world
788# '
789#
790# That would be roughly equivalent to
791#
792# test_expect_success 'test core.capslock' '
793# git config core.capslock true &&
794# hello world
795# git config --unset core.capslock
796# '
797#
798# except that the greeting and config --unset must both succeed for
799# the test to pass.
b586744a
JH
800#
801# Note that under --immediate mode, no clean-up is done to help diagnose
802# what went wrong.
3bf78867
JN
803
804test_when_finished () {
b6b0afdc
JN
805 test_cleanup="{ $*
806 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
3bf78867
JN
807}
808
0509eb21 809# Most tests can use the created repository, but some may need to create more.
eedf8f97
CW
810# Usage: test_create_repo <directory>
811test_create_repo () {
812 test "$#" = 1 ||
813 error "bug in the test script: not 1 parameter to test-create-repo"
eedf8f97 814 repo="$1"
bfdbee98 815 mkdir -p "$repo"
0d314ce8
ÆAB
816 (
817 cd "$repo" || error "Cannot setup test environment"
818 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
819 error "cannot run git init -- have you built things yet?"
820 mv .git/hooks .git/hooks-disabled
821 ) || exit
eedf8f97 822}
a6080a0a 823
e1970ce4 824test_done () {
6e7b5aaf 825 GIT_EXIT_OK=t
2d84e9fb 826
8ef1abe5
ÆAB
827 if test -z "$HARNESS_ACTIVE"; then
828 test_results_dir="$TEST_DIRECTORY/test-results"
829 mkdir -p "$test_results_dir"
830 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
831
c54e6be7
ML
832 cat >>"$test_results_path" <<-EOF
833 total $test_count
834 success $test_success
835 fixed $test_fixed
836 broken $test_broken
837 failed $test_failure
838
839 EOF
8ef1abe5 840 fi
41ac414e
JH
841
842 if test "$test_fixed" != 0
843 then
5099b99d 844 say_color pass "# fixed $test_fixed known breakage(s)"
41ac414e
JH
845 fi
846 if test "$test_broken" != 0
847 then
5099b99d 848 say_color error "# still have $test_broken known breakage(s)"
11d54b8b
JH
849 msg="remaining $(($test_count-$test_broken)) test(s)"
850 else
851 msg="$test_count test(s)"
41ac414e 852 fi
e1970ce4 853 case "$test_failure" in
10b94e28 854 0)
5099b99d
ÆAB
855 # Maybe print SKIP message
856 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
857
d998bd4a
ÆAB
858 if test $test_external_has_tap -eq 0; then
859 say_color pass "# passed all $msg"
860 say "1..$test_count$skip_all"
861 fi
abc5d372
JS
862
863 test -d "$remove_trash" &&
864 cd "$(dirname "$remove_trash")" &&
865 rm -rf "$(basename "$remove_trash")"
866
e1970ce4
JH
867 exit 0 ;;
868
869 *)
d998bd4a
ÆAB
870 if test $test_external_has_tap -eq 0; then
871 say_color error "# failed $test_failure among $msg"
872 say "1..$test_count"
873 fi
5099b99d 874
e1970ce4
JH
875 exit 1 ;;
876
877 esac
878}
879
880# Test the binaries we have just built. The tests are kept in
9adefee5 881# t/ subdirectory and are run in 'trash directory' subdirectory.
62f53904
ÆAB
882if test -z "$TEST_DIRECTORY"
883then
884 # We allow tests to override this, in case they want to run tests
885 # outside of t/, e.g. for running tests on the test library
886 # itself.
887 TEST_DIRECTORY=$(pwd)
888fi
6cec5c68
ÆAB
889GIT_BUILD_DIR="$TEST_DIRECTORY"/..
890
e4597aae 891if test -n "$valgrind"
4e1be63c 892then
4e1be63c
JS
893 make_symlink () {
894 test -h "$2" &&
895 test "$1" = "$(readlink "$2")" || {
896 # be super paranoid
897 if mkdir "$2".lock
898 then
899 rm -f "$2" &&
900 ln -s "$1" "$2" &&
901 rm -r "$2".lock
902 else
903 while test -d "$2".lock
904 do
905 say "Waiting for lock on $2."
906 sleep 1
907 done
908 fi
909 }
910 }
911
912 make_valgrind_symlink () {
36bfb0e5
JK
913 # handle only executables, unless they are shell libraries that
914 # need to be in the exec-path. We will just use "#!" as a
915 # guess for a shell-script, since we have no idea what the user
916 # may have configured as the shell path.
917 test -x "$1" ||
918 test "#!" = "$(head -c 2 <"$1")" ||
919 return;
4e1be63c
JS
920
921 base=$(basename "$1")
6cec5c68 922 symlink_target=$GIT_BUILD_DIR/$base
4e1be63c
JS
923 # do not override scripts
924 if test -x "$symlink_target" &&
925 test ! -d "$symlink_target" &&
926 test "#!" != "$(head -c 2 < "$symlink_target")"
927 then
928 symlink_target=../valgrind.sh
929 fi
efd92ffd
JS
930 case "$base" in
931 *.sh|*.perl)
932 symlink_target=../unprocessed-script
933 esac
4e1be63c
JS
934 # create the link, or replace it if it is out of date
935 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
936 }
937
938 # override all git executables in TEST_DIRECTORY/..
939 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
940 mkdir -p "$GIT_VALGRIND"/bin
6cec5c68 941 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
4e1be63c
JS
942 do
943 make_valgrind_symlink $file
944 done
efd92ffd
JS
945 OLDIFS=$IFS
946 IFS=:
947 for path in $PATH
948 do
949 ls "$path"/git-* 2> /dev/null |
950 while read file
951 do
952 make_valgrind_symlink "$file"
953 done
954 done
955 IFS=$OLDIFS
4e1be63c
JS
956 PATH=$GIT_VALGRIND/bin:$PATH
957 GIT_EXEC_PATH=$GIT_VALGRIND/bin
958 export GIT_VALGRIND
e4597aae
MO
959elif test -n "$GIT_TEST_INSTALLED" ; then
960 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
961 error "Cannot run git from $GIT_TEST_INSTALLED."
6cec5c68 962 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
e4597aae
MO
963 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
964else # normal case, use ../bin-wrappers only unless $with_dashes:
6cec5c68 965 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
e4597aae
MO
966 if ! test -x "$git_bin_dir/git" ; then
967 if test -z "$with_dashes" ; then
968 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
969 fi
970 with_dashes=t
971 fi
972 PATH="$git_bin_dir:$PATH"
6cec5c68 973 GIT_EXEC_PATH=$GIT_BUILD_DIR
e4597aae 974 if test -n "$with_dashes" ; then
6cec5c68 975 PATH="$GIT_BUILD_DIR:$PATH"
e4597aae 976 fi
4e1be63c 977fi
6cec5c68 978GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
8bfa6bd6 979unset GIT_CONFIG
8bfa6bd6 980GIT_CONFIG_NOSYSTEM=1
3c995beb 981GIT_ATTR_NOSYSTEM=1
8f323c00 982export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
49ccb087 983
aed604c7 984. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
ac10a857 985
5e87eae9
JH
986if test -z "$GIT_TEST_CMP"
987then
988 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
989 then
990 GIT_TEST_CMP="$DIFF -c"
991 else
992 GIT_TEST_CMP="$DIFF -u"
993 fi
994fi
995
6cec5c68 996GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
6fcca938 997export GITPERLLIB
6cec5c68 998test -d "$GIT_BUILD_DIR"/templates/blt || {
eea42069
JH
999 error "You haven't built things yet, have you?"
1000}
e1970ce4 1001
ac10a857 1002if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
2fe40b63 1003then
6cec5c68 1004 GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
2fe40b63 1005 export GITPYTHONLIB
6cec5c68 1006 test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
2fe40b63
SR
1007 error "You haven't built git_remote_helpers yet, have you?"
1008 }
1009fi
1010
6cec5c68 1011if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
56cf9806
EW
1012 echo >&2 'You need to build test-chmtime:'
1013 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
1014 exit 1
1015fi
1016
e1970ce4 1017# Test repository
abc5d372 1018test="trash directory.$(basename "$0" .sh)"
f423ef5f
JK
1019test -n "$root" && test="$root/$test"
1020case "$test" in
1021/*) TRASH_DIRECTORY="$test" ;;
1022 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
1023esac
91c8b825 1024test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
8d14ac94 1025rm -fr "$test" || {
6e7b5aaf 1026 GIT_EXIT_OK=t
8d14ac94
JH
1027 echo >&5 "FATAL: Cannot prepare test area"
1028 exit 1
1029}
1030
90cff968
AR
1031HOME="$TRASH_DIRECTORY"
1032export HOME
1033
4a7aaccd 1034test_create_repo "$test"
1bd9c648
LW
1035# Use -P to resolve symlinks in our working directory so that the cwd
1036# in subprocesses like git equals our $PWD (for pathname comparisons).
1037cd -P "$test" || exit 1
04ece593 1038
d5d9de1b
JS
1039this_test=${0##*/}
1040this_test=${this_test%%-*}
04ece593
JH
1041for skp in $GIT_SKIP_TESTS
1042do
47e67d47
MG
1043 case "$this_test" in
1044 $skp)
55db1df0 1045 say_color skip >&3 "skipping test $this_test altogether"
637ab29b 1046 skip_all="skip all tests in $this_test"
04ece593
JH
1047 test_done
1048 esac
1049done
f17e9fbb 1050
8648732e
BC
1051# Provide an implementation of the 'yes' utility
1052yes () {
1053 if test $# = 0
1054 then
1055 y=y
1056 else
1057 y="$*"
1058 fi
1059
1060 while echo "$y"
1061 do
1062 :
1063 done
1064}
1065
f17e9fbb
JS
1066# Fix some commands on Windows
1067case $(uname -s) in
1068*MINGW*)
1069 # Windows has its own (incompatible) sort and find
1070 sort () {
1071 /usr/bin/sort "$@"
1072 }
1073 find () {
1074 /usr/bin/find "$@"
1075 }
5397ea31
JS
1076 sum () {
1077 md5sum "$@"
1078 }
4114156a
JS
1079 # git sees Windows-style pwd
1080 pwd () {
1081 builtin pwd -W
1082 }
ee9fb68c 1083 # no POSIX permissions
6fd1106a 1084 # backslashes in pathspec are converted to '/'
fb9a2bea 1085 # exec does not inherit the PID
a94114ad 1086 test_set_prereq MINGW
a31d0665
RJ
1087 test_set_prereq SED_STRIPS_CR
1088 ;;
1089*CYGWIN*)
1090 test_set_prereq POSIXPERM
a31d0665
RJ
1091 test_set_prereq EXECKEEPSPID
1092 test_set_prereq NOT_MINGW
1093 test_set_prereq SED_STRIPS_CR
ee9fb68c
JS
1094 ;;
1095*)
1096 test_set_prereq POSIXPERM
6fd1106a 1097 test_set_prereq BSLASHPSPEC
fb9a2bea 1098 test_set_prereq EXECKEEPSPID
3ba9ba8f 1099 test_set_prereq NOT_MINGW
f17e9fbb
JS
1100 ;;
1101esac
704a3143 1102
1b19ccd2 1103test -z "$NO_PERL" && test_set_prereq PERL
d4e1b47a 1104test -z "$NO_PYTHON" && test_set_prereq PYTHON
8f852ce6 1105test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
1b19ccd2 1106
bb946bba 1107# Can we rely on git's output in the C locale?
30955229
JN
1108if test -n "$GETTEXT_POISON"
1109then
1110 GIT_GETTEXT_POISON=YesPlease
1111 export GIT_GETTEXT_POISON
1112else
1113 test_set_prereq C_LOCALE_OUTPUT
1114fi
bb946bba 1115
cabdee2c
JH
1116# Use this instead of test_cmp to compare files that contain expected and
1117# actual output from git commands that can be translated. When running
1118# under GETTEXT_POISON this pretends that the command produced expected
1119# results.
1120test_i18ncmp () {
1121 test -n "$GETTEXT_POISON" || test_cmp "$@"
1122}
1123
127df8c6
JH
1124# Use this instead of "grep expected-string actual" to see if the
1125# output from a git command that can be translated either contains an
1126# expected string, or does not contain an unwanted one. When running
1127# under GETTEXT_POISON this pretends that the command produced expected
1128# results.
1129test_i18ngrep () {
1130 if test -n "$GETTEXT_POISON"
1131 then
1132 : # pretend success
1133 elif test "x!" = "x$1"
1134 then
1135 shift
1136 ! grep "$@"
1137 else
1138 grep "$@"
1139 fi
1140}
1141
704a3143
JS
1142# test whether the filesystem supports symbolic links
1143ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1144rm -f y
c91cfd19
ÆAB
1145
1146# When the tests are run as root, permission tests will report that
1147# things are writable when they shouldn't be.
1148test -w / || test_set_prereq SANITY